config/routes.rb
Rails.application.routes.draw do
  devise_for :users
  resources :scores

  resources :works

  resources :work_records

  root 'users#show'

end

app/models/work.rb
class Work < ActiveRecord::Base
  has_many :work_records, dependent: :destroy
  belongs_to :user

  scope :belongs_to_user, ->(user_id){ where(user_id: user_id) }

  def checked?(date)
    not work_records.when(date).empty?
  end
end

app/controllers/works_controller.rb
class WorksController < ApplicationController
  before_action :set_work, only: [:show, :edit, :update, :destroy]

  # GET /works
  # GET /works.json
  def index
    @works = Work.belongs_to_user(current_user.id)
    @work = Work.new
    @form_options = {remote: true}
  end

  # GET /works/1
  # GET /works/1.json
  def show
  end

  # GET /works/new
  def new
    @work = Work.new
  end

  # GET /works/1/edit
  def edit
  end

  # POST /works
  # POST /works.json
  def create
    @work = Work.new(work_params)
    @work.user_id = current_user.id
    @works = Work.belongs_to_user(current_user.id)

    respond_to do |format|
      if @work.save
        format.html { redirect_to @work, notice: 'Work was successfully created.' }
        format.json { render :show, status: :created, location: @work }
        format.js { @notice = 'Work was successfully created.' }
      else
        format.html { render :new }
        format.json { render json: @work.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /works/1
  # PATCH/PUT /works/1.json
  def update
    respond_to do |format|
      if @work.update(work_params)
        format.html { redirect_to @work, notice: 'Work was successfully updated.' }
        format.json { render :show, status: :ok, location: @work }
      else
        format.html { render :edit }
        format.json { render json: @work.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /works/1
  # DELETE /works/1.json
  def destroy
    @work.destroy
    @works = Work.belongs_to_user(current_user.id)
    respond_to do |format|
      format.html { redirect_to works_url, notice: 'Work was successfully destroyed.' }
      format.json { head :no_content }
      format.js { @notice = 'Work was successfully destroyed.' }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_work
      @work = Work.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def work_params
      params.require(:work).permit(:name, :description)
    end
end

app/helpers/works_helper.rb
module WorksHelper
end

app/views/works/_form.html.erb
<%= form_for(@work, @form_options ||= {}) do |f| %>
  <% if @work.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@work.errors.count, "error") %> prohibited this work from being saved:</h2>

      <ul>
      <% @work.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :name %><br>
    <%= f.text_field :name %>
  </div>
  <div class="field">
    <%= f.label :description %><br>
    <%= f.text_field :description %>
  </div>
  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/works/_work_list.html.erb
<table>
  <thead>
    <tr>
      <th>Name</th>
      <th>Description</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @works.each do |work| %>
      <tr>
        <td><%= work.name %></td>
        <td><%= work.description %></td>
        <td><%= link_to 'Show', work %></td>
        <td><%= link_to 'Edit', edit_work_path(work) %></td>
        <td><%= link_to 'Destroy', work, method: :delete, remote: true %></td>
      </tr>
    <% end %>
  </tbody>
</table>

app/views/works/create.js.erb
$('#notice').html('<%= escape_javascript(@notice) %>')
$('#work_list').html('<%= escape_javascript( render 'work_list' )%>');

app/views/works/destroy.js.erb
$('#notice').html('<%= escape_javascript(@notice) %>');
$('#work_list').html('<%= escape_javascript(render 'work_list') %>');

app/views/works/edit.html.erb
<h1>Editing Work</h1>

<%= render 'form' %>

<%= link_to 'Show', @work %> |
<%= link_to 'Back', works_path %>

app/views/works/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Listing Works</h1>

<div id="work_list">
  <%= render 'work_list' %>
</div>

<br>
<%= render 'form'%>

app/views/works/new.html.erb
<h1>New Work</h1>

<%= render 'form' %>

<%= link_to 'Back', works_path %>

app/views/works/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Name:</strong>
  <%= @work.name %>
</p>

<p>
  <strong>Description:</strong>
  <%= @work.description %>
</p>

<%= link_to 'Edit', edit_work_path(@work) %> |
<%= link_to 'Back', works_path %>